local Gnoll = _G.Gnoll
local GL = Gnoll.Locale
local GLW = Gnoll.WoWLocale

local function OnEnterButton(self,link)
		GameTooltip:SetOwner(self, "ANCHOR_NONE")
		GameTooltip:SetPoint("BOTTOM", self, "LEFT", 0, 5)
		if link ~= nil then
			GameTooltip:SetHyperlink(link)
		end
end

local function OnLeaveButton(self)
	GameTooltip:Hide()
end

local function OnEnterButtonIcon(self,arg1,arg2)
	GameTooltip:SetOwner(self, "ANCHOR_NONE")
	GameTooltip:SetPoint("BOTTOM", self, "LEFT", 0, 5)
	if arg1 ~= nil then
		if arg2 == "solo" then -- einzell
			GameTooltip:SetText(arg1)
		elseif type(arg1) == "table" then -- Doppelwährung
			GameTooltip:SetText(arg1[1].." "..arg2[1].." & "..arg1[2].." "..arg2[2])
		end
	end
		
end

---------------------------------------------
---------------------------------------------
---------------------------------------------

function CreateItemButtons(Frame)
	ItemButtons = { { } }
	for i=1, 30 do
		if i <= 10 then
			abstand = i*40
			spalte = 55
		elseif i >= 11 and i <= 20 then 
			 abstand = (i-10) *40
			 spalte = 250+55
		elseif i >= 21 and i <= 30 then
			 abstand = (i-20) *40
			 spalte = 500+55
		end
			
		ItemButtons[i] = CreateFrame("Button", nil, Frame)
		button = ItemButtons[i]
		button:SetPoint("Topleft", Frame, 0+spalte-32, 0-abstand)
		button:SetWidth(232)
		button:SetHeight(32)
		local fo = button:CreateFontString()
		fo:SetFont("Fonts/FRIZQT__.TTF",11)
		fo:SetPoint("LEFT", button, "LEFT", 34,8)
		button:SetFontString(fo)
		
		local ntex = button:CreateTexture()
		ntex:SetTexture("Interface/FrameGeneral/UI-Background-Marble")
		ntex:SetAlpha(0.8) 
		ntex:SetAllPoints()
		button:SetNormalTexture(ntex)
		button:SetScript("OnLeave", OnLeaveButton)
		button:Hide()

		button.icon = CreateFrame("Button", nil, button)
		icon = button.icon
		icon:SetPoint("Left", button, 0, 0)
		icon:SetWidth(32)
		icon:SetHeight(32)
		icon:SetScript("OnLeave", OnLeaveButton)
		
		local itex = icon:CreateTexture()
		itex:SetTexture("Interface\ICONS\Ability_Creature_Cursed_03")
		itex:SetAllPoints()
		icon:SetNormalTexture(itex)
		icon:Show()
		
		local fo = icon:CreateFontString()
		fo:SetFont("Fonts/FRIZQT__.TTF",9)
		fo:SetPoint("LEFT", button, "LEFT", 34,-10)
		icon:SetFontString(fo)
		
		button.currency = CreateFrame("Button", nil, button)
		CurTex = button.currency
		CurTex:SetPoint("BOTTOM", button, 10, 0)
		CurTex:SetScript("OnLeave", OnLeaveButton)
		CurTex:SetWidth(200)
		CurTex:SetHeight(12)
		CurTex:Hide()
	end
end

function ClearItemButtons()
	for i=1,30 do
		ItemButtons[i]:Hide()
		ItemButtons[i]:SetScript("OnEnter",OnLeaveButton)
		ItemButtons[i].icon:SetScript("OnEnter",OnLeaveButton)
		ItemButtons[i].currency:SetScript("OnEnter",OnLeaveButton)
	end
end

---------------------------------------------
---------------------------------------------
---------------------------------------------

function ShowItemPage(self,button,arg1,arg2)
	local itemTable = arg1
	local seite = -1
	local maxsites = math.ceil(#itemTable / 30)
	
	if arg2 == nil then 
		seite = 1 
	else 
		if arg2 > maxsites then
			seite = maxsites
		elseif arg2 < 1 then
			seite = 1
		else
			seite = arg2 
		end
	end 
	local start = 30 * seite -29
	local ende = 30 * seite
	
	ItemPagetext:SetText(string.format("|cFFFFFFFF"..GL["Page %d of %d"], seite,maxsites))
	
	---Buttons mit Funktionen belegen
	ItemSeiteLinks:SetScript("OnMouseDown", function(self, button,arg1,arg2)
		ShowItemPage(self,button,itemTable, seite -1)
	end)
	ItemSeiteRechts:SetScript("OnMouseDown", function(self, button,arg1,arg2)
		ShowItemPage(self, button,itemTable, seite +1)
	end)
	
	ItemFrame:SetScript("OnMouseWheel", function(self, delta)
      ShowItemPage(self, button,itemTable, seite - delta)
	end)
	
	
	
	
	if ende >= #itemTable then -- more Items ?
		ItemSeiteRechts:Hide()
	else
		ItemSeiteRechts:Show()
	end
	
	if seite > 1 then 
		ItemSeiteLinks:Show()
	else
		ItemSeiteLinks:Hide()
	end
	
	if #itemTable < ende then -- not enough items :(
		ende = #itemTable
	end
	
	local buttonid = 1
	for i = start, ende do
		 
		 
		 
		 
		-------- TrennerDesign
		if string.find(itemTable[i][1],"d###") ~= nil then
			ItemButtons[buttonid]:SetText(itemTable[i][2])
			ItemButtons[buttonid]:SetAlpha(1)
			ItemButtons[buttonid].icon:SetAlpha(0)
			ItemButtons[buttonid]:Show()
			
		elseif string.find(itemTable[i][1],"s###") ~= nil then
			tmp = tonumber(itemTable[i][2])
			ItemButtons[buttonid]:SetText(GLW["Difficulty"][tmp])
			ItemButtons[buttonid]:SetAlpha(1)
			ItemButtons[buttonid].icon:SetAlpha(0)
		
		elseif string.find(itemTable[i][1],"x###") ~= nil then
			tmp = tonumber(itemTable[i][2])
			ItemButtons[buttonid]:SetText(GLW["Specs"][tmp])
			ItemButtons[buttonid]:SetAlpha(1)
			ItemButtons[buttonid].icon:SetAlpha(0)
		
		elseif string.find(itemTable[i][1],"t###") ~= nil then
			if itemTable[i][2] == "" then
				ItemButtons[buttonid]:SetText("Platzhalter")
				ItemButtons[buttonid]:SetAlpha(0)
				
			elseif strlen(itemTable[i][2]) == 1 then
				tmp = tonumber(itemTable[i][2])
				ItemButtons[buttonid]:SetText(GLW["Ruf"][tmp])
				ItemButtons[buttonid]:SetAlpha(1)
				
			elseif strlen(itemTable[i][2]) == 2 then
				tmp = tonumber(itemTable[i][2])-30
				ItemButtons[buttonid]:SetText(GLW["Classes"][tmp])
				ItemButtons[buttonid]:SetAlpha(1)
				
			else
				ItemButtons[buttonid]:SetText(GL[itemTable[i][2]])
				ItemButtons[buttonid]:SetAlpha(1)
			end
		
			
			ItemButtons[buttonid].icon:SetAlpha(0)
			ItemButtons[buttonid].currency:Hide()
			ItemButtons[buttonid]:Show()
			
			ItemButtons[buttonid]:SetScript("OnEnter", function(self,arg1)
				OnEnterButton(self)
			end)
			
			ItemButtons[buttonid].icon:SetScript("OnEnter", function(self,arg1)
				OnEnterButton(self)
			end)
			
			
		else
			--Inhalt
			local _, _, Farbe = string.find(itemTable[i][2],"|?c?f?f?(%x*)")
			local _, _, ItemName = string.find(itemTable[i][2],"|?h?%[?([^%[%]]*)%]")
			if strlen(ItemName) > 30 then ItemName = strsub(ItemName,0,30).."..." end --- irgendwie 3 punkte anfügen
			ItemButtons[buttonid]:SetText("|cff"..Farbe..ItemName)
			
			
			---------------Währung
			if itemTable[i][4] == "" then  -- rücken
				ItemButtons[buttonid].icon:SetText(itemTable[i][3])
				ItemButtons[buttonid].currency:Hide()
				
			elseif itemTable[i][4] == "solo" then -- einzell
				ItemButtons[buttonid].icon:SetText(itemTable[i][3])
				ItemButtons[buttonid].currency:Show()
				ItemButtons[buttonid].currency:SetScript("OnEnter", function(self,arg1)
					OnEnterButtonIcon(self,itemTable[i][3],"solo")
				end)
			elseif type(itemTable[i][3]) == "table" then -- Doppelwährung
				ItemButtons[buttonid].icon:SetText(itemTable[i][3][1].." "..itemTable[i][4][1].." & "..itemTable[i][3][2].." "..itemTable[i][4][2])
				ItemButtons[buttonid].currency:Show()
				ItemButtons[buttonid].currency:SetScript("OnEnter", function(self,arg1)
					OnEnterButtonIcon(self,itemTable[i][3],itemTable[i][4])
				end)
			else
				ItemButtons[buttonid].icon:SetText(itemTable[i][3].." - "..itemTable[i][4]) -- noramles item
				ItemButtons[buttonid].currency:Hide()
			end
			
			---Tooltips
			ItemButtons[buttonid]:SetScript("OnEnter", function(self,arg1)
				OnEnterButton(self,itemTable[i][2])
			end)
			
			ItemButtons[buttonid].icon:SetScript("OnEnter", function(self,arg1)
				OnEnterButton(self,itemTable[i][2])
			end)
			
			--Buttongeklicke
			ItemButtons[buttonid]:SetScript("OnClick", function(self, button)  -- reagiert nicht auf rightbutton ?? ka why
				if button == "LeftButton" then 
					if(IsShiftKeyDown()) then
						local e = DEFAULT_CHAT_FRAME.editBox
						ChatEdit_ActivateChat(e)
						local tmp = e:GetText()
						e:SetText(tmp .. itemTable[i][2])
					elseif(IsControlKeyDown()) then
						DressUpItemLink(itemTable[i][2])
					elseif(IsAltKeyDown()) then
						local kontinent = tonumber(DDME["selectedID"])
						local instanz  = tonumber(DDMI["selectedID"])
						local boss = tonumber(DDMB["selectedID"])
						if type(Gnoll.DB["wunschliste"][itemTable[i][1]]) ~= "table" then
							Gnoll.DB["wunschliste"][itemTable[i][1]] = { itemTable[i][2] ,kontinent,instanz,boss}
							print(itemTable[i][2].." "..GL["ItemWishlistADD"])
						else
							Gnoll.DB["wunschliste"][itemTable[i][1]] = nil
							print(itemTable[i][2].." "..GL["ItemWishlistDEL"])
						end
					end
				end
			end)
			--Buttongeklicke fürs Icon
			ItemButtons[buttonid].icon:SetScript("OnClick", function(self, button)  -- reagiert nicht auf rightbutton ?? ka why
				if button == "LeftButton" then 
					if(IsShiftKeyDown()) then
						local e = DEFAULT_CHAT_FRAME.editBox
						ChatEdit_ActivateChat(e)
						local tmp = e:GetText()
						e:SetText(tmp .. itemTable[i][2])
					elseif(IsControlKeyDown()) then
						DressUpItemLink(itemTable[i][2])
					elseif(IsAltKeyDown()) then
						local kontinent = tonumber(DDME["selectedID"])
						local instanz  = tonumber(DDMI["selectedID"])
						local boss = tonumber(DDMB["selectedID"])
						if type(Gnoll.DB["wunschliste"][itemTable[i][1]]) ~= "table" then
							Gnoll.DB["wunschliste"][itemTable[i][1]] = { itemTable[i][2] ,kontinent,instanz,boss}
							print(itemTable[i][2].." "..GL["ItemWishlistADD"])
						else
							Gnoll.DB["wunschliste"][itemTable[i][1]] = nil
							print(itemTable[i][2].." "..GL["ItemWishlistDEL"])
						end
					end
				end
			end)
			
			
			
			texture = GetItemIcon(itemTable[i][1])
			ItemButtons[buttonid].icon:SetNormalTexture(texture)
			ItemButtons[buttonid].icon:SetAlpha(1)
			ItemButtons[buttonid]:SetAlpha(1)
			ItemButtons[buttonid]:Show()
		end
		buttonid = buttonid +1
	end
	
	if buttonid < 30 then -- not enough items :(
		for i = buttonid, 30 do
			ItemButtons[buttonid]:Hide()
			buttonid = buttonid +1
		end
	end
end

---------------------------------------------
---------------------------------------------
---------------------------------------------

function UpdateItems(itemTable)
	ItemSeiteRechts:Hide()
	ItemSeiteLinks:Hide()
	ClearItemButtons()
	local x = 0
	local maxsites = math.ceil(#itemTable / 30)
		
	ItemPagetext:SetText(string.format("|cFFFFFFFF"..GL["Page %d of %d"], 1,maxsites))
	
	if #itemTable > 30 then   --- Es gibt mehr als 1 Seite
		x = 30
		ItemSeiteRechts:Show()
		ItemSeiteRechts:SetScript("OnMouseDown", function(self, button, arg1,arg2)
		ShowItemPage(self, button, itemTable,2) end)
	else
		x = #itemTable
	end
	
	for i = 1, x do
		
		if itemTable[i][2] == nil then
			ItemButtons[i]:SetText("Getting ItemInfo")
			ItemButtons[i].icon:SetText("")
			ItemFrame:SetScript("OnMouseWheel", function(self, delta) end)
			
			
			ItemButtons[i]:SetScript("OnEnter", function(self,arg1)
				OnEnterButton(self)
			end)
	
		---Trenner Design
		elseif string.find(itemTable[i][1],"d###") ~= nil then
				ItemButtons[i]:SetText(itemTable[i][2])
				ItemButtons[i]:SetAlpha(1)
				ItemButtons[i].icon:SetAlpha(0)
				
		elseif string.find(itemTable[i][1],"s###") ~= nil then
				tmp = tonumber(itemTable[i][2])
				ItemButtons[i]:SetText(GLW["Difficulty"][tmp])
				ItemButtons[i].icon:SetAlpha(0)
				ItemButtons[i]:SetAlpha(1)
		
		elseif string.find(itemTable[i][1],"x###") ~= nil then
				tmp = tonumber(itemTable[i][2])
				ItemButtons[i]:SetText(GLW["Specs"][tmp])
				ItemButtons[i].icon:SetAlpha(0)
				ItemButtons[i]:SetAlpha(1)
				
		elseif string.find(itemTable[i][1],"t###")  ~= nil then	--- Platzhalter

			if itemTable[i][2] == "" then
				ItemButtons[i]:SetText("PlatzHalter")
				ItemButtons[i]:SetAlpha(0)
			
			elseif strlen(itemTable[i][2]) == 1 then	--- Ruf
				tmp = tonumber(itemTable[i][2])
				ItemButtons[i]:SetText(GLW["Ruf"][tmp])
				ItemButtons[i].icon:SetText("")
				ItemButtons[i]:SetAlpha(1)
				
			elseif strlen(itemTable[i][2]) == 2 then
				tmp = tonumber(itemTable[i][2])-30
				ItemButtons[i]:SetText(GLW["Classes"][tmp])
				ItemButtons[i]:SetAlpha(1)
	
			else
				ItemButtons[i]:SetText(GL[itemTable[i][2]])	--- TrennerText
				ItemButtons[i].icon:SetText("")
				ItemButtons[i]:SetAlpha(1)
			end
		
		
			ItemButtons[i].icon:SetAlpha(0)
			ItemButtons[i].currency:Hide()
			ItemButtons[i]:SetScript("OnEnter", function(self,arg1)
				OnEnterButton(self)
			end)
			ItemButtons[i].icon:SetScript("OnEnter", function(self,arg1)
				OnEnterButton(self)
			end)
		else
			ItemFrame:SetScript("OnMouseWheel", function(self, delta)
				ShowItemPage(self, button, itemTable, delta)
			end)
	
			--Inhalt
			local _, _, Farbe = string.find(itemTable[i][2],"|?c?f?f?(%x*)")
			local _, _, ItemName = string.find(itemTable[i][2],"|?h?%[?([^%[%]]*)%]")
			if strlen(ItemName) > 30 then ItemName = strsub(ItemName,0,30).."..." end 
			ItemButtons[i]:SetText("|cff"..Farbe..ItemName)
			
			---Design der Wärhung
			if itemTable[i][4] == "" then  -- rücken
				ItemButtons[i].icon:SetText(itemTable[i][3])
				ItemButtons[i].currency:Hide()
				
			elseif itemTable[i][4] == "solo" then -- einzell
				ItemButtons[i].icon:SetText(itemTable[i][3])
				ItemButtons[i].currency:Show()
				ItemButtons[i].currency:SetScript("OnEnter", function(self,arg1)
				OnEnterButtonIcon(self,itemTable[i][3],"solo")
				end)
				
				elseif type(itemTable[i][3]) == "table" then -- Doppelwährung
				ItemButtons[i].icon:SetText(itemTable[i][3][1].." "..itemTable[i][4][1].." & "..itemTable[i][3][2].." "..itemTable[i][4][2])
				ItemButtons[i].currency:Show()
				ItemButtons[i].currency:SetScript("OnEnter", function(self,arg1)
				OnEnterButtonIcon(self,itemTable[i][3],itemTable[i][4])
				end)
				
			else
				ItemButtons[i].icon:SetText(itemTable[i][3].." - "..itemTable[i][4]) -- noramles item
				ItemButtons[i].currency:Hide()
			end
			
			------Tooltips			
			ItemButtons[i]:SetScript("OnEnter", function(self,arg1)
				OnEnterButton(self,itemTable[i][2])
			end)
			
			ItemButtons[i].icon:SetScript("OnEnter", function(self,arg1)
				OnEnterButton(self,itemTable[i][2])
			end)
			
			

			--Buttongeklcike
			ItemButtons[i]:SetScript("OnClick", function(self, button)
				if button == "LeftButton" then 
					if(IsShiftKeyDown()) then
						local e = DEFAULT_CHAT_FRAME.editBox
						ChatEdit_ActivateChat(e)
						local tmp = e:GetText()
						e:SetText(tmp .. itemTable[i][2])
					elseif(IsControlKeyDown()) then
						DressUpItemLink(itemTable[i][2])
					elseif(IsAltKeyDown()) then
						local kontinent = tonumber(DDME["selectedID"])
						local instanz  = tonumber(DDMI["selectedID"])
						local boss = tonumber(DDMB["selectedID"])
						if type(Gnoll.DB["wunschliste"][itemTable[i][1]]) ~= "table" then
							Gnoll.DB["wunschliste"][itemTable[i][1]] = { itemTable[i][2] ,kontinent,instanz,boss}
							print(itemTable[i][2].." "..GL["ItemWishlistADD"])
						else
							Gnoll.DB["wunschliste"][itemTable[i][1]] = nil
							print(itemTable[i][2].." "..GL["ItemWishlistDEL"])
						end
					end
				end
			end)
			--Buttongeklcike für Icons
			ItemButtons[i].icon:SetScript("OnClick", function(self, button)
				if button == "LeftButton" then 
					if(IsShiftKeyDown()) then
						local e = DEFAULT_CHAT_FRAME.editBox
						ChatEdit_ActivateChat(e)
						local tmp = e:GetText()
						e:SetText(tmp .. itemTable[i][2])
					elseif(IsControlKeyDown()) then
						DressUpItemLink(itemTable[i][2])
					elseif(IsAltKeyDown()) then
						local kontinent = tonumber(DDME["selectedID"])
						local instanz  = tonumber(DDMI["selectedID"])
						local boss = tonumber(DDMB["selectedID"])
						if type(Gnoll.DB["wunschliste"][itemTable[i][1]]) ~= "table" then
							Gnoll.DB["wunschliste"][itemTable[i][1]] = { itemTable[i][2] ,kontinent,instanz,boss}
							print(itemTable[i][2].." "..GL["ItemWishlistADD"])
						else
							Gnoll.DB["wunschliste"][itemTable[i][1]] = nil
							print(itemTable[i][2].." "..GL["ItemWishlistDEL"])
						end
					end
				end
			end)
			
			------Icons
			texture = GetItemIcon(itemTable[i][1])
			ItemButtons[i].icon:SetNormalTexture(texture)
			ItemButtons[i].icon:SetAlpha(1)
			ItemButtons[i]:SetAlpha(1)
		end
		
		
		if i <= 30 then
			ItemButtons[i]:Show()
		end
		
	end
end

