local _G = _G
local LDB = LibStub("LibDataBroker-1.1", true)
local icon = LibStub("LibDBIcon-1.0")
_G.Gnoll =  {}

local MainMT = {
	__tostring = function(self)
		return AddonNameVersion
	end,
}
setmetatable(_G.Gnoll, MainMT)

function newtable(dim)
    local MT = {};
    for i=1, dim do
        MT[i] = {__index = function(t, k)
            if i < dim then
                t[k] = setmetatable({}, MT[i+1])
                return t[k];
            end
        end}
    end
    return setmetatable({}, MT[1]);
end

_G.Gnoll.Locale = {}
_G.Gnoll.WoWLocale = {}
_G.Gnoll.Data = {} 
_G.Gnoll.DB = {} 


local frame = CreateFrame("FRAME")
frame:RegisterEvent("ADDON_LOADED")
frame:RegisterEvent("PLAYER_LOGOUT")

function frame:OnEvent(event, arg1)
	if event == "ADDON_LOADED" and string.lower(arg1) == "gnoll" then
		local GL = Gnoll.Locale
	
		---Datenbankverwaltung
		if type(GnollDatabase) ~= "table" then -- neue DB anlegen
			print("[Gnoll] Default Database loaded.")
			GnollDatabase = { }
			GnollDatabase["wunschliste"] = {}
			GnollDatabase["favoriten"] = {}
			GnollDatabase["opt"] = { }
			GnollDatabase["opt"]["welcome"] = true
			GnollDatabase["opt"]["minimap"] = {}
			GnollDatabase["opt"]["minimap"]["lock"] = false
			GnollDatabase["opt"]["minimap"]["hide"] = false
		 
		else --- Features einzeln adden
			if type(GnollDatabase["wunschliste"]) ~= "table" then
				GnollDatabase["wunschliste"] = {}
				print("[Gnoll] New Feature: Wishlist ")
			end
			
			if type(GnollDatabase["favoriten"]) ~= "table" then
				GnollDatabase["favoriten"] = {}
				print("[Gnoll] New Feature: Favourites ")
			end
			
			if type(GnollDatabase["opt"]) ~= "table" then
				GnollDatabase["opt"] = {}
				GnollDatabase["opt"]["welcome"] = true
				GnollDatabase["opt"]["minimap"] = {}
				GnollDatabase["opt"]["minimap"]["lock"] = false
				GnollDatabase["opt"]["minimap"]["hide"] = false

				print("[Gnoll] New Feature: Options ")
			end
		end
		_G.Gnoll.DB = GnollDatabase
		
		---- Welcome Msgs
		if GnollDatabase["opt"]["welcome"] == true then
			print(GL["Welcome"])
		end

		---- LDB
		local GnollLauncher = LDB:NewDataObject("Gnoll", {
		type = "launcher",
		text = "Gnoll",
		label = "Gnoll",
		icon = "Interface\\Minimap\\tracking\\Banker",
		OnClick = OnClickMinimap,
		OnTooltipShow = function(tt)
			tt:AddLine("|cff00bfffGnoll|r v399")
			tt:AddLine("|cff00bfff"..GL["MapML"])
			tt:AddLine("|cff00bfff"..GL["MapMR"])
		end, })
		
		
		
		---- Icon
		icon:Register("Gnoll", GnollLauncher, GnollDatabase["opt"]["minimap"])
		if GnollDatabase["opt"]["minimap"]["lock"] ~= false then
			icon:Lock("Gnoll")
		end
		
		if GnollDatabase["opt"]["minimap"]["hide"] then
			icon:Hide("Gnoll")
		end

	end
end
frame:SetScript("OnEvent", frame.OnEvent);

 



